const express = require("express");
const router = express.Router();
const multer = require("multer");
const authorize = require("../../../../middlewares/authorize-sapps");
const sasaranMutuServices = require("./sasaranMutu.service");

const storage = multer.diskStorage({
  destination: function (req, file, cb) {
    cb(null, "./public/data/images/");
  },
  filename: function (req, file, cb) {
    cb(null, Date.now() + "-" + file.originalname);
  },
});

const upload = multer({ storage: storage });

router.post("/create", authorize(), create);
router.post("/", authorize(), getAll);
router.get("/filter", authorize(), filter);
router.get("/option", authorize(), option);
router.get("/count", authorize(), count);
router.put("/:id", authorize(), update);
router.put("/enabled/:id", authorize(), enabled);
router.delete("/:id", authorize(), _delete);

module.exports = router;

function create(req, res, next) {
  sasaranMutuServices
    .create(req.body)
    .then((result) => res.json(result))
    .catch(next);
}
function getAll(req, res, next) {
  sasaranMutuServices
    .getAll(req.body)
    .then((result) => res.json(result))
    .catch(next);
}

function filter(req, res, next) {
  sasaranMutuServices
    .filter(req.query)
    .then((result) => res.json(result))
    .catch(next);
}

function option(req, res, next) {
  sasaranMutuServices
    .option()
    .then((result) => res.json(result))
    .catch(next);
}

function count(req, res, next) {
  sasaranMutuServices
    .count()
    .then((result) => res.json(result))
    .catch(next);
}

function update(req, res, next) {
  sasaranMutuServices
    .update(req.params.id, req.body)
    .then((result) => res.json(result))
    .catch(next);
}

function enabled(req, res, next) {
  sasaranMutuServices
    .enabled(req.params.id, req.body)
    .then((result) => res.json(result))
    .catch(next);
}

function _delete(req, res, next) {
  sasaranMutuServices
    .delete(req.params.id)
    .then((result) => res.json(result))
    .catch(next);
}
